#pragma once

#include "NPCommonUI.h"
#include "NToolTipMgr.h"

interface IToolTipDelegate;

/**
 * \group NPCommonUI 
 * \date 2008/01/16
 * \author hhd2002
 * \brief {kr} CNToolTip Class {/kr}
 * \remark {kr} 
	 νϽ
	 ƮѺ 1 .
	 Ʈѵ ؽƮ,    Ʈ   ִ  ؾ .
	 Ʈ ڵ鸵ϴ Ŵ ҵ .
 {/kr} 
 */
class NPCOMMONUI_API CNToolTip
	: public INToolTip
{
public:
	CNToolTip();
	virtual ~CNToolTip();
	
	//override
	//INToolTip
	void SetVisible(BOOL bVisible);
	BOOL IsVisible();

	//properties
	/**
	 * \breif {kr}	θƮ . 
					θƮ Ŵ ͸  . {/kr}
	 */
	void SetOwner(CComponent* pOwner);
	/**
	 * \breif {kr}	 Է.
					νϽ   ؾ. {/kr}
	 */
	void SetMargin(LPRECT prcMargin);
	/**
	 * \breif {kr}  . {/kr}
	 */
	void GetMargin(OUT LPRECT prcMargin);
	/**
	* \breif {kr}	븮 .
					νϽ  ؽƮ  񵿱  ټ ִ 븮ڸ .{/kr}
	*/
	void SetDelegate(IToolTipDelegate* pDelegate);
	/**
	 * \breif {kr} ؽƮ . {/kr}
	 */
	void SetText(LPCTSTR szText);
	/**
	 * \breif {kr}	 ۵Ǵ ġ .
					  Ʈ left-top  (0,0)  Ʈ Է¹. {/kr}
	 * \remark {kr} Ʈ(=ppt) Ʈ   Ǹ ȵ.
					 Ʈ  Ǵ Ʈ Ǹ ߻Ŵ. 
					ֳϸ Ʈ   Ǹ 콺 Ͱ ̴ٰ
					Ʈ      콺ƿ ̺Ʈ ߻ǰ
					  . {/kr}
	 */
	void SetPosition(LPPOINT ppt);

	//methods
	/**
	 * \breif {kr}   ؽƮ ѹ Ʈ. {/kr}
	 */
	void Update();
protected:
private:

	/**
	 * \breif {kr}	Ŵ ͸  .
					Ŵ  ؽƮ ȭ ݿϰ  Ŵ   Ȳ  . {/kr}
	 */
	CNToolTipMgr* _LoadToolTipMgr();
	void _UpdatePosition();

	BOOL m_bVisible;
	CComponent* m_pOwner;
	IToolTipDelegate* m_pDelegate;
	POINT m_ptOffset;
	POINT m_ptTrack;
	RECT m_rcMargin;
	TCHAR m_szText[CNToolTipMgr::Prop_MaxTextLength];
	TOOLINFO m_Info;
};

// PM-637 2007/10/18 23:08:10 
/* {kr}
̴ ÷ ߿ ġ Ҷ  Ǿ ϴµ,
 ó ؼ  ̴ ؽƮ   ϰ Ǿ.
{/kr} */
/**
* \group NPCommonUI
* \date 2007-10-12
* \author hhd
* \brief {kr}  ؽƮ   ִ 븮. {/kr} 
*/
interface IToolTipDelegate
{
public:
	/**
	* \brief {kr} ؽƮ ܺο . {/kr}
	* \param szToolTip {kr} [in] ܺο Էϴ ؽƮ. {/kr}
	*/
	virtual void GetToolTipText(LPTSTR szToolTip) = 0;
};